package tests;

import java.io.File;

import javax.xml.parsers.DocumentBuilderFactory;


import org.w3c.dom.Document;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.its.IProcessor;
import org.w3c.its.ITSProcessor;

public class ITSTest {

	public static void main (String[] args)
		throws Exception
	{
		DocumentBuilderFactory dbFact = DocumentBuilderFactory.newInstance();
		dbFact.setNamespaceAware(true);
		dbFact.setValidating(false);
		
		String inputPath = "C:\\Tmp\\BorneoTests\\XML\\Test01.xml";
		Document doc = dbFact.newDocumentBuilder().parse(new File(inputPath));
		
		ITSProcessor proc = new ITSProcessor(doc, inputPath);
		proc.applyRules(IProcessor.DC_ALL);
		
		proc.startTraversal();
		Node node;
		while ( proc.nextNode() ) {
			node = proc.getNode();
			switch ( node.getNodeType() ) {
			case Node.ELEMENT_NODE:
				System.out.print("<"+node.getNodeName());
				if ( node.hasAttributes() ) {
					NamedNodeMap attrs = node.getAttributes();
					for ( int i=0; i<attrs.getLength(); i++ ) {
						System.out.print(" "+attrs.item(i).getNodeName() + "=\""
							+ attrs.item(i).getNodeValue() + "\"");
					}
				}
				System.out.print(" its='"+node.getUserData("\u00ff")+"'");
				System.out.print(">");
				break;
			case Node.TEXT_NODE:
				if ( proc.translate() ) {
					System.out.print(node.getTextContent());
				}
				else {
					String tmpText = node.getTextContent().replaceAll("\\p{Lu}", "X");
					System.out.print(tmpText.replaceAll("\\p{Ll}", "x"));
				}
				break;
			}
		}
	}
	
	static void traverse (ITSProcessor proc,
		Node node) {
		if ( node == null ) return;
		
		switch ( node.getNodeType() ) {
		case Node.ELEMENT_NODE:
			System.out.print("<"+node.getNodeName());
			if ( node.hasAttributes() ) {
				NamedNodeMap attrs = node.getAttributes();
				for ( int i=0; i<attrs.getLength(); i++ ) {
					System.out.print(" "+attrs.item(i).getNodeName() + "=\""
						+ attrs.item(i).getNodeValue() + "\"");
				}
			}
			System.out.print(" its='"+node.getUserData("\u00ff")+"'");
			System.out.print(">");
			break;
		case Node.TEXT_NODE:
			if ( proc.translate() ) {
				System.out.print(node.getTextContent());
			}
			else {
				String tmpText = node.getTextContent().replaceAll("\\p{Lu}", "X");
				System.out.print(tmpText.replaceAll("\\p{Ll}", "x"));
			}
			break;
		}
		
		if ( node.hasChildNodes() ) {
			traverse(proc, node.getFirstChild());
		}
		if ( node.getNextSibling() != null ) {
			traverse(proc, node.getNextSibling());
		}
		
		switch ( node.getNodeType() ) {
		case Node.ELEMENT_NODE:
			System.out.print("</"+node.getNodeName()+">");
			break;
		}
		
	}
}
